<div  class="container-m--x bredcrumb admin-bg" style="margin-top:-11.9px;">
    <div  class="row px-4 f-16 white">
        <div  class="col-md-4">
            <span (click)="goToDefaultPage()" class="cursor"><i  class="las la-home f-18 "></i></span>
            <span  class="px-3"><i  class="las la-angle-right f-12 "></i></span>
            <span class="font-weight-normal">Administration</span></div></div></div>
<!-- <div class="row mt-2 justify-content-md-center">
</div> -->
<div>
    <div class="content">
        <div class="content_width">
            <div class="row">
                <div class="col-md-3 sidebar_top">
                <admin-sidebar></admin-sidebar> 
                </div>
                <div class="col-md-9 card_title_top">
                    <label>
                        <h2 class="card-title-material">User Management</h2>
                    </label>
                    <div class="table-wrapper mt-2">
                        <div class="row">
                            <div class="search-box">
                                <div class="input-group">
                                    <span class="input-group-addon input_group_margin"><i class="las la-search fa-lg search_icon_transform"></i>
                                    </span >
                                    <input type="text" id="search" class="form-control search_input search_bg"
                                        placeholder="Search Users" autocomplete="off" (keyup)='updateFilter($event)'>
                                </div>
                            </div>
                            <div class="add_user_ctn">
                                <button class="btn btn-md btn-primary pull-right"
                                    (click)="openAddUserModal(AddNewUserModal, { windowClass: 'modal-fill-in modal-lg animate',backdrop: 'static', keyboard: false })">
                                    <span class="fa fa-plus"></span> Add User
                                </button>
                            </div>
                        </div>

                        <div *ngIf="!detectmob()"
                            class="card-ngx-datatable table-responsive table table-striped table-hover">
                            <ngx-datatable #table  [rows]="rows" style="min-width: 50vh"
                                [loadingIndicator]="loadingIndicator"  [columnMode]="'standard'" [scrollbarH]="scrollBarHorizontal"  [columnMode]="'force'" [headerHeight]="33"
                                [footerHeight]="'auto'" [rowHeight]="'auto'" [reorderable]="true" [limit]="15">

                                <ngx-datatable-column name="Firstname" [width]="150">
                                    <ng-template  let-column="column" ngx-datatable-header-template>
                                        First Name
                                    </ng-template>
                                </ngx-datatable-column>
                                <ngx-datatable-column name="Lastname" [width]="130">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Last Name
                                    </ng-template>
                                </ngx-datatable-column>

                                <ngx-datatable-column name="Email" [width]="370" style="white-space: nowrap;
                                overflow: hidden;
                                text-overflow: ellipsis;">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Email Address
                                    </ng-template>
                                </ngx-datatable-column>
                                <!-- <ngx-datatable-column name="Active">
                                        <ng-template let-column="column" ngx-datatable-header-template>
                                            Status
                                        </ng-template>
                                        <ng-template let-value="value" ngx-datatable-cell-template>
                                            <span *ngIf="value == '2'" class="text-default">Created</span>
                                            <span *ngIf="value == '1'" class="text-success">Active</span>
                                            <span *ngIf="value == '0'" class="text-danger">Inactive</span>
                                        </ng-template>
                                    </ngx-datatable-column> -->
                                <ngx-datatable-column name="activestat" [width]="100">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Status
                                    </ng-template>
                                </ngx-datatable-column>
                                <ngx-datatable-column name="opration" [width]="100">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Active
                                    </ng-template>
                                    <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                        <label class="switcher switcher-success  " placement="top"
                                            [ngbTooltip]="row['opration']">
                                            <input type="checkbox" (change)="suspend(value,row['active']==1?0:1)"
                                                class="switcher-input" [checked]="row['active']"
                                                [disabled]="row['active']>1">
                                            <span class="switcher-indicator">
                                                <span class="switcher-yes">
                                                    <span class="ion ion-md-checkmark"></span>
                                                </span>
                                                <span class="switcher-no">
                                                    <span class="ion ion-md-close"></span>
                                                </span>
                                            </span>
                                        </label>
                                    </ng-template>
                                </ngx-datatable-column>
                                <ngx-datatable-column name="Role" [width]="250">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Role
                                    </ng-template>
                                    <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                        <div class="ml-0 p-2 mb-2 mr-2 row w-100 text-justified" *ngFor="let r of value">{{r.role}}</div>
                                    </ng-template>
                                </ngx-datatable-column>

                                <ngx-datatable-column name="opration" [width]="100">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Manage
                                    </ng-template>
                                    <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                        <button class="btn custom-icon-btn btn-sm btn-outline-info  borderless"
                                            placement="top" ngbTooltip="Edit"
                                            (click)="edit(value,EditUserModal,{windowClass: 'modal-fill-in modal-md animate',backdrop: 'static', keyboard: false})">
                                            <i class="fa-lg las la-edit"></i>
                                        </button>

                                        <button class="btn custom-icon-btn btn-sm btn-outline-danger  borderless"
                                            placement="top" ngbTooltip="Delete" (click)="confirmDelete(DeleteModal, { windowClass: 'modal-fill-in modal-lg animate',backdrop: 'static', keyboard: false },value)"
                                            [disabled]="row['admin']" style="background: none;
                                        color: black;">
                                            <i class="fa-lg las la-trash"></i>
                                        </button>
                                    </ng-template>
                                </ngx-datatable-column>
                            </ngx-datatable>
                        </div>
                        <div *ngIf="detectmob()" class="card-ngx-datatable table-responsive">
                            <ngx-datatable #table style="min-width: 30vh" [rows]="rows"
                                [loadingIndicator]="loadingIndicator" [scrollbarH]="scrollBarHorizontal"  [columnMode]="'force'" [headerHeight]="33"
                                [footerHeight]="'auto'" [rowHeight]="'auto'" [reorderable]="true" [limit]="15">

                                <ngx-datatable-column name="Firstname" [width]="150">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        First Name
                                    </ng-template>
                                </ngx-datatable-column>
                                <ngx-datatable-column name="Lastname" [width]="130">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Last Name
                                    </ng-template>
                                </ngx-datatable-column>

                                <ngx-datatable-column name="Email" [width]="370">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Email Address
                                    </ng-template>
                                </ngx-datatable-column>
                                <!-- <ngx-datatable-column name="Active">
                                            <ng-template let-column="column" ngx-datatable-header-template>
                                                Status
                                            </ng-template>
                                            <ng-template let-value="value" ngx-datatable-cell-template>
                                                <span *ngIf="value == '2'" class="text-default">Created</span>
                                                <span *ngIf="value == '1'" class="text-success">Active</span>
                                                <span *ngIf="value == '0'" class="text-danger">Inactive</span>
                                            </ng-template>
                                        </ngx-datatable-column> -->
                                <ngx-datatable-column name="activestat">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Status
                                    </ng-template>
                                </ngx-datatable-column>
                                <ngx-datatable-column name="Role">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Role
                                    </ng-template>
                                    <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                        <span class="badge badge-default ml-0 p-2 mb-2 mr-2"
                                            *ngFor="let r of value">{{r.role}}</span>
                                    </ng-template>
                                </ngx-datatable-column>

                                <ngx-datatable-column name="opration">
                                    <ng-template let-column="column" ngx-datatable-header-template>
                                        Manage
                                    </ng-template>
                                    <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                        <button class="btn btn-sm btn-outline-info tooltipMob borderless"
                                            (press)="onLongPress('Edit')" (pressUp)="onPressUp()" (tap)="edit(value)">
                                            <i class="fa-lg las la-edit"></i>
                                            <span class="tooltiptext"
                                                *ngIf="mobTooltipStr != ''">{{mobTooltipStr}}</span>
                                        </button>
                                        <button class="btn btn-sm btn-outline-danger tooltipMob borderless"
                                            (press)="onLongPress('Delete')" (pressUp)="onPressUp()"
                                            (tap)="delete(value)" [disabled]="row['admin']" style="background: none;
                                        color: black;">
                                            <i class="fa-lg las la-trash"></i>
                                            <span class="tooltiptext"
                                                *ngIf="mobTooltipStr != ''">{{mobTooltipStr}}</span>
                                        </button>
                                        <label class="switcher switcher-success">
                                            <input type="checkbox" (change)="suspend(value,row['active']==1?0:1)"
                                                class="switcher-input" [checked]="row['active']"
                                                [disabled]="row['active']>1">
                                            <span class="switcher-indicator">
                                                <span class="switcher-yes">
                                                    <span class="ion ion-md-checkmark"></span>
                                                </span>
                                                <span class="switcher-no">
                                                    <span class="ion ion-md-close"></span>
                                                </span>
                                            </span>
                                        </label>
                                    </ng-template>
                                </ngx-datatable-column>
                            </ngx-datatable>
                            <div class="clearfix">
                                <div class="hint-text">Showing <b>5</b> out of <b>25</b> entries</div>
                                <ul class="pagination">
                                    <li class="page-item disabled"><a href="#">Previous</a></li>
                                    <li class="page-item"><a href="#" class="page-link">1</a></li>
                                    <li class="page-item"><a href="#" class="page-link">2</a></li>
                                    <li class="page-item active"><a href="#" class="page-link">3</a></li>
                                    <li class="page-item"><a href="#" class="page-link">4</a></li>
                                    <li class="page-item"><a href="#" class="page-link">5</a></li>
                                    <li class="page-item"><a href="#" class="page-link">Next</a></li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<ng-template #AddNewUserModal let-c="close" let-d="dismiss">
    <div class="admin_panel modal-header">
        <h5 class="modal-title">
            Add New User
        </h5>
        <button type="button" class="close" (click)="d('Cross click');">&times;</button>
    </div>
    <div class="modal-body">
        <h6 class="modal-title pb-3">Enter the User Information</h6>
        <form [formGroup]="addUser">

            <div class="form-row">
                <div class="form-group col-md-6">
                    <label class="form-label">First Name</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Enter your First Name">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                    <input [formControl]="addUser.controls['first_name']" name="first_name" type="text"
                        class="form-control" placeholder="First Name"
                        [ngClass]="{'is-invalid':!addUser.controls['first_name'].valid && addUser.controls['first_name'].touched}">
                    <div *ngIf="addUser.controls['first_name'].hasError('required') && addUser.controls['first_name'].touched"
                        class="invalid-feedback">You must include a first name.</div>
                </div>

                <div class="form-group col-md-6">
                    <label class="form-label">Last Name</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Enter your Last Name">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                    <input [formControl]="addUser.controls['last_name']" name="last_name" type="text"
                        class="form-control" placeholder="Last Name"
                        [ngClass]="{'is-invalid':!addUser.controls['last_name'].valid && addUser.controls['last_name'].touched}">
                    <div *ngIf="addUser.controls['last_name'].hasError('required') && addUser.controls['last_name'].touched"
                        class="invalid-feedback">You must include a last name.</div>
                </div>
            </div>

            <div class="form-row">
                <div class="form-group col-md-6">
                    <label class="form-label">Email</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Enter your Email">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                    <input [formControl]="addUser.controls['uid']" name="email" type="email" class="form-control"
                        placeholder="Email"
                        [ngClass]="{'is-invalid':!addUser.controls['uid'].valid && addUser.controls['uid'].touched}">
                    <div *ngIf="addUser.controls['uid'].hasError('required') && addUser.controls['uid'].touched"
                        class="invalid-feedback">You must include an Email.</div>
                    <div *ngIf="addUser.controls['uid'].hasError('pattern') && addUser.controls['uid'].touched"
                        class="invalid-feedback">Invalid Email.</div>
                </div>
            </div>

            <div class="form-row">
                <div class="form-group col-md-12">
                    <label class="form-label">Roles</label>
                    <span class="ml-2  " placement="top" ngbTooltip="select Role">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>
                    <ng-select style="color:#a4a4a4;" [formControl]="addUser.controls['role']" [multiple]="true"
                        [options]="roleList" placeholder="Eg: State Manager, Store Manager" [(ngModel)]="role"
                        [ngClass]="!addUser.controls['role'].valid && addUser.controls['role'].touched?'is-invalid ng-select-info':'ng-select-info'">
                    </ng-select>
                    <div *ngIf="addUser.controls['role'].hasError('required') && addUser.controls['role'].touched"
                        class="invalid-feedback">You must select at least one role.</div>
                </div>
            </div>

            <div class="form-row">
                <div *ngIf="isStore" class="form-group col-md-12">
                    <label class="form-label">Stores</label>
                    <span class="ml-2  " placement="top" ngbTooltip="select Store">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                    <ng-select style="color:#a4a4a4;" [formControl]="addUser.controls['storelist']" [multiple]="true"
                        [options]="storeList" placeholder="Eg: Store1, Store2" [(ngModel)]="storelist"
                        [ngClass]="!addUser.controls['storelist'].valid && addUser.controls['storelist'].touched?'is-invalid ng-select-info':'ng-select-info'">
                    </ng-select>
                    <!-- <div *ngIf="addUser.controls['storelist'].hasError('required') && addUser.controls['storelist'].touched" class="invalid-feedback">You must select at least one store.</div> -->
                </div>
            </div>
        </form>
    </div>
    
    <div class="admin_panel modal-footer">
        <button class="btn btn-default" (click)="c('Cross click');">Cancel</button>
        <button (click)="addNewUser(addUser.value)" class="btn btn-primary"
            [disabled]="!addUser.valid || isloading">Create User</button>
    </div>
</ng-template>
<ng-template #EditUserModal let-c="close" let-d="dismiss">
    <div class="admin_panel modal-header">
        <h5 class="modal-title">
            Edit - {{uid}}
        </h5>
        <button type="button" class="close" (click)="d('Cross click');">&times;</button>
    </div>
    <div class="modal-body">
        <form [formGroup]="editUser" (ngSubmit)="fneditUser(editUser.value)">
            <div class="form-row">
                <div class="form-group col-md-6">
                    <label class="form-label">First Name</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Enter your First Name">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                    <input [formControl]="editUser.controls['first_name']" [(ngModel)]="first_name" name="first_name"
                        type="text" class="form-control" placeholder="First Name"
                        [ngClass]="{'is-invalid':!editUser.controls['first_name'].valid && editUser.controls['first_name'].touched}">
                    <div *ngIf="editUser.controls['first_name'].hasError('required') && editUser.controls['first_name'].touched"
                        class="invalid-feedback">You must include a first name.</div>
                </div>
                <div class="form-group col-md-6">
                    <label class="form-label">Last Name</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Enter your Last Name">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>
                    <input [formControl]="editUser.controls['last_name']" [(ngModel)]="last_name" name="last_name"
                        type="text" class="form-control" placeholder="Last Name"
                        [ngClass]="{'is-invalid':!editUser.controls['last_name'].valid && editUser.controls['last_name'].touched}">
                    <div *ngIf="editUser.controls['last_name'].hasError('required') && editUser.controls['last_name'].touched"
                        class="invalid-feedback">You must include a last name.</div>
                </div>
                <!-- <div class="form-group col-md-6">
                            <label class="form-label">Role</label>
                            <select [formControl]="editUser.controls['role']" [(ngModel)]="role" class="form-control">
                                <option *ngIf="roleList.length==0" [value]="0" selected>Loading....</option>
                                <option *ngFor="let role of roleList" [value]="role.role">{{role.description}}</option>
                            </select>
                        </div> -->
                <div class="form-group col-md-12">
                    <label class="form-label">Roles</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Select Role">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>
                    <ng-select style="color:#a4a4a4;" placeholder="Eg: State Manager, Store Mamager"
                        [formControl]="editUser.controls['role']" [multiple]="true" [options]="roleList"
                        [(ngModel)]="role"
                        [ngClass]="!editUser.controls['role'].valid && editUser.controls['role'].touched?'is-invalid ng-select-primary':'ng-select-primary'">
                    </ng-select>
                    <div *ngIf="editUser.controls['role'].hasError('required') && editUser.controls['role'].touched"
                        class="invalid-feedback">You must include at least one role.</div>
                </div>
                <div *ngIf="isStore" class="form-group col-md-12">
                    <label class="form-label">Stores</label>
                    <span class="ml-2  " placement="top" ngbTooltip="Select Store">
                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                    <ng-select style="color:#a4a4a4;" placeholder="Eg: Store1, Store2"
                        [formControl]="editUser.controls['storelist']" [multiple]="true" [options]="storeListArr"
                        [(ngModel)]="storelist"
                        [ngClass]="!editUser.controls['storelist'].valid && editUser.controls['storelist'].touched?'is-invalid ng-select-primary':'ng-select-primary'">
                    </ng-select>
                    <!-- <div *ngIf="editUser.controls['storelist'].hasError('required') && editUser.controls['storelist'].touched" class="invalid-feedback">You must select at least one store.</div> -->
                </div>
                <input [formControl]="editUser.controls['uid']" [(ngModel)]="uid" name="uid" type="hidden"
                    class="form-control" placeholder="Email">
            </div>
            <!-- <hr/>
                    
                    <button [ladda]="isloading" data-style="expand-left" type="submit" class="btn btn-primary btn-material float-right" [disabled]="!editUser.valid">Update</button>
                    <button class="btn btn-default mr-1 float-right" (click)="goBack()">Cancel</button> -->
        </form>
    </div>
  
    <div class="admin_panel modal-footer">
        <button class="btn btn-default" (click)="c('Cross click');">Cancel</button>
        <button (click)="fneditUser(editUser.value)" class="btn btn-primary btn-material float-right"
            [disabled]="!editUser.valid || isloading">Update</button>
    </div>
</ng-template>
<div *blockUI="'global-loader'; template: blockTemplate"></div>
<ng-template #blockTemplate>
    <div class="block-ui-template">
        <div class="app-splash-screen ">
            <div class="new-app-splash-screen-content text-center">
                <img src="../../assets/img/hx-loader-logo.svg" class="loader-svg">
                <span class="loading-text-material">
                </span>
            </div>
        </div>
    </div>
</ng-template>
<ng-template #DeleteModal let-c="close" let-d="dismiss" class="modal fade-scale" >
    <div class="modal-header">
        <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
            <span class="font-weight-light">Confirmation</span>
        </h2>

        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>

    <div class="modal-body">
        <!-- <h3>Are you sure?</h3> -->
        <p class="mb-0 unpin-text">Do you want to delete? {{uid}}</p>
    </div>

    <div class="modal-footer">
        <button type="button" class="btn btn-primary btn-material"
            (click)="delete(uid);c('Close click')">Yes, delete it!</button>
        <button type="button" class="btn btn-default" (click)="c('Close click')">Cancel</button>
    </div>
</ng-template>